com.amazonaws.services.workspaces

## Class AbstractAmazonWorkspaces

- java.lang.Object
- - com.amazonaws.services.workspaces.AbstractAmazonWorkspaces

All Implemented Interfaces:
  AmazonWorkspaces

Direct Known Subclasses:
  AbstractAmazonWorkspacesAsync

    public class AbstractAmazonWorkspaces
    extends Object
    implements AmazonWorkspaces

Abstract implementation of `AmazonWorkspaces`. Convenient method forms pass through to the corresponding overload that takes a request object, which throws an `UnsupportedOperationException`.

### Field Summary

### Fields inherited from interface com.amazonaws.services.workspaces.AmazonWorkspaces

`ENDPOINT_PREFIX`

### Constructor Summary

Constructors
`protected` `AbstractAmazonWorkspaces()`

### Method Summary

All Methods Instance Methods Concrete Methods
`CreateTagsResult` `createTags(CreateTagsRequest request)` Creates tags for a WorkSpace.
`CreateWorkspacesResult` `createWorkspaces(CreateWorkspacesRequest request)` Creates one or more WorkSpaces.
`DeleteTagsResult` `deleteTags(DeleteTagsRequest request)` Deletes tags from a WorkSpace.
`DescribeTagsResult` `describeTags(DescribeTagsRequest request)` Describes tags for a WorkSpace.
`DescribeWorkspaceBundlesResult` `describeWorkspaceBundles()` Simplified method form for invoking the DescribeWorkspaceBundles operation.
`DescribeWorkspaceBundlesResult` `describeWorkspaceBundles(DescribeWorkspaceBundlesRequest request)` Obtains information about the WorkSpace bundles that are available to your account in the specified region.
`DescribeWorkspaceDirectoriesResult` `describeWorkspaceDirectories()` Simplified method form for invoking the DescribeWorkspaceDirectories operation.
`DescribeWorkspaceDirectoriesResult` `describeWorkspaceDirectories(DescribeWorkspaceDirectoriesRequest request)` Retrieves information about the AWS Directory Service directories in the region that are registered with Amazon WorkSpaces and are available to your account.
`DescribeWorkspacesResult` `describeWorkspaces()` Simplified method form for invoking the DescribeWorkspaces operation.
`DescribeWorkspacesResult` `describeWorkspaces(DescribeWorkspacesRequest request)` Obtains information about the specified WorkSpaces.
`DescribeWorkspacesConnectionStatusResult` `describeWorkspacesConnectionStatus(DescribeWorkspacesConnectionStatusRequest request)` Describes the connection status of a specified WorkSpace.
`ResponseMetadata` `getCachedResponseMetadata(AmazonWebServiceRequest request)` Returns additional metadata for a previously executed successful request, typically used for debugging issues where a service isn't acting as expected.
`ModifyWorkspacePropertiesResult` `modifyWorkspaceProperties(ModifyWorkspacePropertiesRequest request)` Modifies the WorkSpace properties, including the RunningMode and AutoStop time.
`RebootWorkspacesResult` `rebootWorkspaces(RebootWorkspacesRequest request)` Reboots the specified WorkSpaces.
`RebuildWorkspacesResult` `rebuildWorkspaces(RebuildWorkspacesRequest request)` Rebuilds the specified WorkSpaces.
`void` `setEndpoint(String endpoint)` Overrides the default endpoint for this client ("https://workspaces.us-east-1.amazonaws.com").
`void` `setRegion(Region region)` An alternative to `AmazonWorkspaces.setEndpoint(String)`, sets the regional endpoint for this client's service calls.
`void` `shutdown()` Shuts down this client object, releasing any resources that might be held open.
`StartWorkspacesResult` `startWorkspaces(StartWorkspacesRequest request)` Starts the specified WorkSpaces.
`StopWorkspacesResult` `stopWorkspaces(StopWorkspacesRequest request)` Stops the specified WorkSpaces.
`TerminateWorkspacesResult` `terminateWorkspaces(TerminateWorkspacesRequest request)` Terminates the specified WorkSpaces.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AbstractAmazonWorkspaces

    protected AbstractAmazonWorkspaces()

### Method Detail

#### setEndpoint

    public void setEndpoint(String endpoint)

Description copied from interface: `AmazonWorkspaces`
Overrides the default endpoint for this client ("https://workspaces.us-east-1.amazonaws.com"). Callers can use this method to control which AWS region they want to work with.

Callers can pass in just the endpoint (ex: "workspaces.us-east-1.amazonaws.com") or a full URL, including the protocol (ex: "https://workspaces.us-east-1.amazonaws.com"). If the protocol is not specified here, the default protocol from this client's `ClientConfiguration` will be used, which by default is HTTPS.

For more information on using AWS regions with the AWS SDK for Java, and a complete list of all available endpoints for all AWS services, see: http://developer.amazonwebservices.com/connect/entry.jspa?externalID=3912

This method is not threadsafe. An endpoint should be configured when the client is created and before any service requests are made. Changing it afterwards creates inevitable race conditions for any service requests in transit or retrying.

Specified by:
  `setEndpoint` in interface `AmazonWorkspaces`
Parameters:
  `endpoint` - The endpoint (ex: "workspaces.us-east-1.amazonaws.com") or a full URL, including the protocol (ex: "https://workspaces.us-east-1.amazonaws.com") of the region specific AWS endpoint this client will communicate with.

#### setRegion

    public void setRegion(Region region)

Description copied from interface: `AmazonWorkspaces`
An alternative to `AmazonWorkspaces.setEndpoint(String)`, sets the regional endpoint for this client's service calls. Callers can use this method to control which AWS region they want to work with.

By default, all service endpoints in all regions use the https protocol. To use http instead, specify it in the `ClientConfiguration` supplied at construction.

This method is not threadsafe. A region should be configured when the client is created and before any service requests are made. Changing it afterwards creates inevitable race conditions for any service requests in transit or retrying.

Specified by:
  `setRegion` in interface `AmazonWorkspaces`
Parameters:
  `region` - The region this client will communicate with. See `Region.getRegion(com.amazonaws.regions.Regions)` for accessing a given region. Must not be null and must be a region where the service is available.
See Also:
  `Region.getRegion(com.amazonaws.regions.Regions)`, `Region.createClient(Class, com.amazonaws.auth.AWSCredentialsProvider, ClientConfiguration)`, `Region.isServiceSupported(String)`

#### createTags

    public CreateTagsResult createTags(CreateTagsRequest request)

Description copied from interface: `AmazonWorkspaces`

Creates tags for a WorkSpace.

Specified by:
  `createTags` in interface `AmazonWorkspaces`
Parameters:
  `request` - The request of the CreateTags operation.
Returns:
  Result of the CreateTags operation returned by the service.

#### createWorkspaces

    public CreateWorkspacesResult createWorkspaces(CreateWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Creates one or more WorkSpaces.

<note>

This operation is asynchronous and returns before the WorkSpaces are created.

</note>

Specified by:
  `createWorkspaces` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the CreateWorkspaces operation.
Returns:
  Result of the CreateWorkspaces operation returned by the service.

#### deleteTags

    public DeleteTagsResult deleteTags(DeleteTagsRequest request)

Description copied from interface: `AmazonWorkspaces`

Deletes tags from a WorkSpace.

Specified by:
  `deleteTags` in interface `AmazonWorkspaces`
Parameters:
  `request` - The request of the DeleteTags operation.
Returns:
  Result of the DeleteTags operation returned by the service.

#### describeTags

    public DescribeTagsResult describeTags(DescribeTagsRequest request)

Description copied from interface: `AmazonWorkspaces`

Describes tags for a WorkSpace.

Specified by:
  `describeTags` in interface `AmazonWorkspaces`
Parameters:
  `request` - The request of the DescribeTags operation.
Returns:
  Result of the DescribeTags operation returned by the service.

#### describeWorkspaceBundles

    public DescribeWorkspaceBundlesResult describeWorkspaceBundles(DescribeWorkspaceBundlesRequest request)

Description copied from interface: `AmazonWorkspaces`

Obtains information about the WorkSpace bundles that are available to your account in the specified region.

You can filter the results with either the `BundleIds` parameter, or the `Owner` parameter, but not both.

This operation supports pagination with the use of the `NextToken` request and response parameters. If more results are available, the `NextToken` response member contains a token that you pass in the next call to this operation to retrieve the next set of items.

Specified by:
  `describeWorkspaceBundles` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the DescribeWorkspaceBundles operation.
Returns:
  Result of the DescribeWorkspaceBundles operation returned by the service.

#### describeWorkspaceBundles

    public DescribeWorkspaceBundlesResult describeWorkspaceBundles()

Description copied from interface: `AmazonWorkspaces`
Simplified method form for invoking the DescribeWorkspaceBundles operation.

Specified by:
  `describeWorkspaceBundles` in interface `AmazonWorkspaces`
See Also:
  `AmazonWorkspaces.describeWorkspaceBundles(DescribeWorkspaceBundlesRequest)`

#### describeWorkspaceDirectories

    public DescribeWorkspaceDirectoriesResult describeWorkspaceDirectories(DescribeWorkspaceDirectoriesRequest request)

Description copied from interface: `AmazonWorkspaces`

Retrieves information about the AWS Directory Service directories in the region that are registered with Amazon WorkSpaces and are available to your account.

This operation supports pagination with the use of the `NextToken` request and response parameters. If more results are available, the `NextToken` response member contains a token that you pass in the next call to this operation to retrieve the next set of items.

Specified by:
  `describeWorkspaceDirectories` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the DescribeWorkspaceDirectories operation.
Returns:
  Result of the DescribeWorkspaceDirectories operation returned by the service.

#### describeWorkspaceDirectories

    public DescribeWorkspaceDirectoriesResult describeWorkspaceDirectories()

Description copied from interface: `AmazonWorkspaces`
Simplified method form for invoking the DescribeWorkspaceDirectories operation.

Specified by:
  `describeWorkspaceDirectories` in interface `AmazonWorkspaces`
See Also:
  `AmazonWorkspaces.describeWorkspaceDirectories(DescribeWorkspaceDirectoriesRequest)`

#### describeWorkspaces

    public DescribeWorkspacesResult describeWorkspaces(DescribeWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Obtains information about the specified WorkSpaces.

Only one of the filter parameters, such as `BundleId`, `DirectoryId`, or `WorkspaceIds`, can be specified at a time.

This operation supports pagination with the use of the `NextToken` request and response parameters. If more results are available, the `NextToken` response member contains a token that you pass in the next call to this operation to retrieve the next set of items.

Specified by:
  `describeWorkspaces` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the DescribeWorkspaces operation.
Returns:
  Result of the DescribeWorkspaces operation returned by the service.

#### describeWorkspaces

    public DescribeWorkspacesResult describeWorkspaces()

Description copied from interface: `AmazonWorkspaces`
Simplified method form for invoking the DescribeWorkspaces operation.

Specified by:
  `describeWorkspaces` in interface `AmazonWorkspaces`
See Also:
  `AmazonWorkspaces.describeWorkspaces(DescribeWorkspacesRequest)`

#### describeWorkspacesConnectionStatus

    public DescribeWorkspacesConnectionStatusResult describeWorkspacesConnectionStatus(DescribeWorkspacesConnectionStatusRequest request)

Description copied from interface: `AmazonWorkspaces`

Describes the connection status of a specified WorkSpace.

Specified by:
  `describeWorkspacesConnectionStatus` in interface `AmazonWorkspaces`
Returns:
  Result of the DescribeWorkspacesConnectionStatus operation returned by the service.

#### modifyWorkspaceProperties

    public ModifyWorkspacePropertiesResult modifyWorkspaceProperties(ModifyWorkspacePropertiesRequest request)

Description copied from interface: `AmazonWorkspaces`

Modifies the WorkSpace properties, including the RunningMode and AutoStop time.

Specified by:
  `modifyWorkspaceProperties` in interface `AmazonWorkspaces`
Returns:
  Result of the ModifyWorkspaceProperties operation returned by the service.

#### rebootWorkspaces

    public RebootWorkspacesResult rebootWorkspaces(RebootWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Reboots the specified WorkSpaces.

To be able to reboot a WorkSpace, the WorkSpace must have a State of `AVAILABLE`, `IMPAIRED`, or `INOPERABLE`.

<note>

This operation is asynchronous and returns before the WorkSpaces have rebooted.

</note>

Specified by:
  `rebootWorkspaces` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the RebootWorkspaces operation.
Returns:
  Result of the RebootWorkspaces operation returned by the service.

#### rebuildWorkspaces

    public RebuildWorkspacesResult rebuildWorkspaces(RebuildWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Rebuilds the specified WorkSpaces.

Rebuilding a WorkSpace is a potentially destructive action that can result in the loss of data. Rebuilding a WorkSpace causes the following to occur:

- The system is restored to the image of the bundle that the WorkSpace is created from. Any applications that have been installed, or system settings that have been made since the WorkSpace was created will be lost.

- The data drive (D drive) is re-created from the last automatic snapshot taken of the data drive. The current contents of the data drive are overwritten. Automatic snapshots of the data drive are taken every 12 hours, so the snapshot can be as much as 12 hours old.

To be able to rebuild a WorkSpace, the WorkSpace must have a State of `AVAILABLE` or `ERROR`.

<note>

This operation is asynchronous and returns before the WorkSpaces have been completely rebuilt.

</note>

Specified by:
  `rebuildWorkspaces` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the RebuildWorkspaces operation.
Returns:
  Result of the RebuildWorkspaces operation returned by the service.

#### startWorkspaces

    public StartWorkspacesResult startWorkspaces(StartWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Starts the specified WorkSpaces. The API only works with WorkSpaces that have RunningMode configured as AutoStop and the State set to “STOPPED.”

Specified by:
  `startWorkspaces` in interface `AmazonWorkspaces`
Returns:
  Result of the StartWorkspaces operation returned by the service.

#### stopWorkspaces

    public StopWorkspacesResult stopWorkspaces(StopWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Stops the specified WorkSpaces. The API only works with WorkSpaces that have RunningMode configured as AutoStop and the State set to AVAILABLE, IMPAIRED, UNHEALTHY, or ERROR.

Specified by:
  `stopWorkspaces` in interface `AmazonWorkspaces`
Returns:
  Result of the StopWorkspaces operation returned by the service.

#### terminateWorkspaces

    public TerminateWorkspacesResult terminateWorkspaces(TerminateWorkspacesRequest request)

Description copied from interface: `AmazonWorkspaces`

Terminates the specified WorkSpaces.

Terminating a WorkSpace is a permanent action and cannot be undone. The user's data is not maintained and will be destroyed. If you need to archive any user data, contact Amazon Web Services before terminating the WorkSpace.

You can terminate a WorkSpace that is in any state except `SUSPENDED`.

<note>

This operation is asynchronous and returns before the WorkSpaces have been completely terminated.

</note>

Specified by:
  `terminateWorkspaces` in interface `AmazonWorkspaces`
Parameters:
  `request` - Contains the inputs for the TerminateWorkspaces operation.
Returns:
  Result of the TerminateWorkspaces operation returned by the service.

#### shutdown

    public void shutdown()

Description copied from interface: `AmazonWorkspaces`
Shuts down this client object, releasing any resources that might be held open. This is an optional method, and callers are not expected to call it, but can if they want to explicitly release any open resources. Once a client has been shutdown, it should not be used to make any more requests.

Specified by:
  `shutdown` in interface `AmazonWorkspaces`

#### getCachedResponseMetadata

    public ResponseMetadata getCachedResponseMetadata(AmazonWebServiceRequest request)

Description copied from interface: `AmazonWorkspaces`
Returns additional metadata for a previously executed successful request, typically used for debugging issues where a service isn't acting as expected. This data isn't considered part of the result data returned by an operation, so it's available through this separate, diagnostic interface.

Response metadata is only cached for a limited period of time, so if you need to access this extra diagnostic information for an executed request, you should use this method to retrieve it as soon as possible after executing a request.

Specified by:
  `getCachedResponseMetadata` in interface `AmazonWorkspaces`
Parameters:
  `request` - The originally executed request.
Returns:
  The response metadata for the specified request, or null if none is available.